--== take a guess ==--
ARI_UseSpells = true
ARI_UsePets = true
ARI_UseDots = true
ARI_UseHots = true
ARI_UsePotions = false

ARI_Focus = nil
ARI_Leader = "Scarlet"
ARI_UseCC = nil

ARI_UseSpells = true
ARI_CheckInteractDistanceExtension = false


--== take a guess ==--
function DebugLog( text )
	DEFAULT_CHAT_FRAME:AddMessage( text )
end

function DebugCombatLogRange()
	SetCVar("CombatLogRangeParty", 200)
	SetCVar("CombatLogRangePartyPet", 200)
	SetCVar("CombatLogRangeFriendlyPlayers", 200)
	SetCVar("CombatLogRangeFriendlyPlayersPets", 200)
	SetCVar("CombatLogRangeHostilePlayers", 200)
	SetCVar("CombatLogRangeHostilePlayersPets", 200)
	SetCVar("CombatLogRangeCreature", 200)
	SetCVar("CombatDeathLogRange", 200)
end


--== basic event handling ==--
function ARI_OnLoad()
	SLASH_BOXTOOLS1 = "/bt"
	SLASH_BOXTOOLS2 = "/boxtools"
	SlashCmdList["BOXTOOLS"] = function(msg) ARI_OnCommand(msg) end

	this:RegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE")
	--this:RegisterEvent("CHAT_MSG_ADDON")
	this:RegisterEvent("PLAYER_ENTERING_WORLD")
	this:RegisterEvent("ACTIONBAR_HIDEGRID")
	this:RegisterEvent("SPELLS_CHANGED")
	this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS")
	--this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE")
	this:RegisterEvent("CHAT_MSG_SPELL_AURA_GONE_OTHER")
end

function ARI_OnEvent( event )
	if (event == "CHAT_MSG_SPELL_SELF_DAMAGE") then
		local st, en, cap1, cap2 = string.find(arg1, ARI_LOC_IMMUNE)
		if (st ~= nil) then
			if not ARI_IsImmune(cap1, cap2) then
				ARI_AddImmunity(cap1, cap2)
			end
		end
		return
	end
	if (event == "CHAT_MSG_ADDON") then
		--DebugLog( event .. ", ".. arg1 .. ", " .. arg2 .. ", ".. arg3 .. ", " .. arg4 )
		return
	end
	if (event == "PLAYER_ENTERING_WORLD") then
		ARI_CheckMacros()
		return
	end
	if (event == "ACTIONBAR_HIDEGRID") then
		ARI_UpdateActionSlots()
		return
	end
	if (event == "SPELLS_CHANGED") then
		ARI_UpdateSpellSlots()
		return
	end
	if (event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS") then
		--DebugLog( event .. ", ".. arg1 .. ", " .. arg2 .. ", ".. arg3 .. ", " .. arg4 )
		local st, en, cap1, cap2 = string.find(arg1, ARI_LOC_GAINS)
		if (st ~= nil) then
			--DebugLog( "GAINS: ".. cap1 .. ", " .. cap2 )
			if cap2 == ARI_LOC_AZUREGOS_REFLECTION then
				--"Azuregos gains Reflection."
				ARI_UseSpells = false
				DebugLog( "ARI_UseSpells: false" )
			end
			if cap2 == ARI_LOC_MAJORDOMO_REFLECTION then
				--"Flamewaker Elite gains Magic Reflection."
				ARI_UseSpells = false
				DebugLog( "ARI_UseSpells: false" )
			end
		end
		return
	end
	if (event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE") then
		--DebugLog( event .. ", ".. arg1 .. ", " .. arg2 .. ", ".. arg3 .. ", " .. arg4 )
		local st, en, cap1, cap2 = string.find(arg1, ARI_LOC_IS_AFFLICTED_BY)
		if (st ~= nil) then
			--DebugLog( "IS_AFFLICTED_BY: ".. cap1 .. ", " .. cap2 )
		end
		return
	end
	if (event == "CHAT_MSG_SPELL_AURA_GONE_OTHER") then
		--DebugLog( event .. ", ".. arg1 .. ", " .. arg2 .. ", ".. arg3 .. ", " .. arg4 )
		local st, en, cap1, cap2 = string.find(arg1, ARI_LOC_FADES_FROM)
		if (st ~= nil) then
			if cap1 == ARI_LOC_BANISH then
				--"Banish fades from ..."
				ARI_ResetImmunity(cap2)
			end
			if cap1 == ARI_LOC_DIVINE_SHIELD then
				--"Divine Shield fades from ..."
				ARI_ResetImmunity(cap2)
			end
			if cap1 == ARI_LOC_AZUREGOS_REFLECTION then
				--"Reflection fades from Azuregos."
				ARI_UseSpells = true
				DebugLog( "ARI_UseSpells: true" )
			end
			if cap1 == ARI_LOC_MAJORDOMO_REFLECTION then
				--"Reflection fades from ..."
				ARI_UseSpells = true
				DebugLog( "ARI_UseSpells: true" )
			end
			--DebugLog( "FADES_FROM: ".. cap1 .. ", " .. cap2 )
		end
		return
	end
end

function ARI_OnUpdate()
end

function ARI_OnCommand( msg )
	if (BoxToolsOptions:IsVisible()) then
		PlaySound("gsTitleOptionExit")
		BoxToolsOptions:Hide()
	else
		PlaySound("igMainMenuOption")
		BoxToolsOptions:Show()
	end
end


--== macro logic ==--
function ARI_CheckMacros()
	local class = UnitClass("player")
	local englishClass = nil
	if class == ARI_LOC_WARRIOR then
		englishClass = "Warrior"
	end
	if class == ARI_LOC_HUNTER then
		englishClass = "Hunter"
	end
	if class == ARI_LOC_ROGUE then
		englishClass = "Rogue"
	end
	if class == ARI_LOC_PALADIN then
		englishClass = "Paladin"
	end
	if class == ARI_LOC_DRUID then
		englishClass = "Druid"
	end
	if class == ARI_LOC_PRIEST then
		englishClass = "Priest"
	end
	if class == ARI_LOC_MAGE then
		englishClass = "Mage"
	end
	if class == ARI_LOC_WARLOCK then
		englishClass = "Warlock"
	end
	if class == ARI_LOC_SHAMAN then
		englishClass = "Shaman"
	end
	if englishClass == nil then
		DebugLog("DEBUG: class = " .. class)
	end

	local followMacro = ARI_FindMacro("Follow", "Interface\\Icons\\Ability_Tracking", true)
	local healerMacro = ARI_FindMacro("Healer", "Interface\\Icons\\Spell_Nature_NullWard", false)
	local assistMacro = ARI_FindMacro("Assist", "Interface\\Icons\\Ability_DualWield", false)

	local followBody = "/run ARI_FollowLeader();"
	local healerBody = "/run ARI_Heal" .. englishClass .. "();"
	local assistBody = "/run ARI_" .. englishClass .. "Assist();"

	if (followMacro ~= nil) then
		followMacro = EditMacro( followMacro, "Follow", 147, followBody, 1)
	else
		followMacro = CreateMacro("Follow", 147, followBody, 1, nil)
	end

	if (healerMacro ~= nil) then
		healerMacro = EditMacro( healerMacro, "Healer", 392, healerBody, 1)
	else
		healerMacro = CreateMacro("Healer", 392, healerBody, 1, 1)
	end

	if (assistMacro ~= nil) then
		assistMacro = EditMacro( assistMacro, "Assist", 43, assistBody, 1)
	else
		assistMacro = CreateMacro("Assist", 43, assistBody, 1, 1)
	end
end

function ARI_FindMacro( name, icon, global )
	local numglobal,numperchar = GetNumMacros()

	if global then
		for idx = 1, numglobal do
			local macroName, iconTexture, body, isLocal = GetMacroInfo(idx)
			if ( name == macroName ) and ( icon == iconTexture ) then
				return idx
			end
		end
	else
		for idx = 19, 18 + numperchar do
			local macroName, iconTexture, body, isLocal = GetMacroInfo(idx)
			if ( name == macroName ) and ( icon == iconTexture ) then
				return idx
			end
		end
	end

	return nil
end


--== immunity logic (not to be saved) ==--
ARI_Immunity = {}
function ARI_AddImmunity( spell, npc )
	if ARI_Immunity[npc] == nil then
		ARI_Immunity[npc] = {}
	end
	ARI_Immunity[npc][spell] = true
end

function ARI_ResetImmunity( npc )
	ARI_Immunity[npc] = {}
end


function ARI_IsImmune( spell, npc )
	if ARI_Immunity[npc] == nil then
		return false
	end
	return (ARI_Immunity[npc][spell] ~= nil)
end


--== group logic ==--
ARI_UnitNames = {}
ARI_UnitNamesDead = {}
ARI_UnitNamesBuff = {}
ARI_UnitNamesHeal = {}
function ARI_UpdateUnitNames()
	local possibleUnits = {}
	if UnitInRaid("player") then
		-- check for raid
		local raidSize = GetNumRaidMembers()
		for i = 1, raidSize do
			table.insert(possibleUnits, "raid" .. i)
			table.insert(possibleUnits, "raidpet" .. i)
		end
	else
		-- add self
		table.insert(possibleUnits, "player")
		table.insert(possibleUnits, "pet")

		-- check for party
		local partySize = GetNumPartyMembers()
		for i = 1, partySize do
			table.insert(possibleUnits, "party" .. i)
			table.insert(possibleUnits, "partypet" .. i)
		end
	end

	local validUnits = {}
	for _,unit in pairs(possibleUnits) do
		if UnitExists(unit) then
			if UnitIsVisible(unit) then
				table.insert(validUnits, unit)
			end
		end
	end

	ARI_UnitNames = ARI_ShuffleUnitNames(validUnits)

	-- reset presort lists
	ARI_UnitNamesDead = {}
	ARI_UnitNamesBuff = {}
	ARI_UnitNamesHeal = {}

	-- check for extension
	ARI_CheckInteractDistanceExtension = CheckInteractDistance("player", 7) == 1

	for _,unit in pairs(ARI_UnitNames) do
		if UnitIsDead(unit) then
			table.insert(ARI_UnitNamesDead, unit)
		else
			-- check follow/buff distance (28m/30m)
			if CheckInteractDistance(unit, 4) then
				table.insert(ARI_UnitNamesBuff, unit)
			end
			local inRange = true
			if ARI_CheckInteractDistanceExtension then
				-- check heal distance (40m)
				inRange = CheckInteractDistance(unit, 7)
			end
			if inRange then
				table.insert(ARI_UnitNamesHeal, unit)
			end
		end
	end
end

function ARI_ShuffleUnitNames( unitList )
	local len, random = table.getn(unitList), math.random
	for i = len, 2, -1 do
		local j = random( 1, i )
		unitList[i], unitList[j] = unitList[j], unitList[i]
	end
	return unitList
end


--== leader logic ==--
function ARI_FindLeader()
	local leader = "player"

	for i,unit in pairs(ARI_UnitNames) do
		if UnitName(unit) == ARI_Leader then
			return unit
		end
		if UnitIsPartyLeader(unit) then
			leader = unit
		end
	end

	return leader
end

function ARI_FindFocus()
	if ARI_Focus ~= nil then
		for i,unit in pairs(ARI_UnitNames) do
			if UnitName(unit) == ARI_Focus then
				return unit
			end
		end
	end

	return nil
end

function ARI_FollowLeader()
	ARI_UpdateUnitNames()

	local leader = ARI_FindLeader()
	if UnitExists("pet") then
		PetFollow()
	end
	FollowUnit(leader)
end


--== action logic (not to be saved) ==--
ARI_ActionSlot = nil
function ARI_CheckActionSlots()
	if ARI_ActionSlot == nil then
		ARI_UpdateActionSlots()
	end
	if ARI_SpellSlot == nil then
		ARI_UpdateSpellSlots()
	end
	ARI_SpellCooldown = {}
end

function ARI_UpdateActionSlots()
	ARI_ActionSlot = {}
	for slot = 1, 120 do
		ARI_UpdateActionSlot( slot )
	end
end

function ARI_UpdateActionSlot( slot )
	local slotName
	if HasAction(slot) then
		BoxToolsTooltip:SetAction(slot)
		slotName = tostring(BoxToolsTooltipTextLeft1:GetText())
		ARI_ActionSlot[slotName] = slot
	end
end

function ARI_FindActionSlot( action )
	return ARI_ActionSlot[action]
end

function ARI_IsActionActive( spell )
	local slot = ARI_FindActionSlot(spell)
	if slot ~= nil then
		if IsCurrentAction(slot) == 1 then
			return true
		elseif IsAutoRepeatAction(slot) == 1 then
			return true
		end
	end
	return false
end

function ARI_PlayerIsCasting()
	if CastingBarFrame.casting == 1 then
		return true
	end
	if CastingBarFrame.channeling == 1 then
		return true
	end
	return false
end

function ARI_CastAction( spell )
	return ARI_UnitCastAction(nil, spell)
end

function ARI_UnitCastAction( unit, spell )
	local slot = ARI_FindActionSlot(spell)
	if slot ~= nil then
		local isUsable, notEnoughMana = IsUsableAction(slot)
		if (isUsable ~= 1) then
			return false
		end
		if (notEnoughMana == 1) then
			return false
		end
		if unit ~= nil then
			TargetUnit(unit)
		end
		local inRange = IsActionInRange(slot)
		if (inRange == 0) then
			if unit ~= nil then
				TargetLastTarget()
			end
			return false
		end
		if ARI_SpellIsOnCooldown(spell) then
			if unit ~= nil then
				TargetLastTarget()
			end
			return false
		end
		UseAction(slot)
		if unit ~= nil then
			TargetLastTarget()
		end
		return true
	end
	return false
end

function ARI_IsActionValid( action )
	if ARI_FindActionSlot(action) ~= nil then
		if not ARI_SpellIsOnCooldown(action) then
			return true
		end
	end
	return false
end


--== action/spell logic (not to be saved) ==--
ARI_SpellSlot = nil
ARI_SpellCooldown = nil
function ARI_UpdateSpellSlots()
	ARI_SpellSlot = {}
	local slot, slotName = 1, nil, nil
	while true do
		slotName = GetSpellName(slot, BOOKTYPE_SPELL)
		if (slotName == nil) then
			return false
		end
		ARI_SpellSlot[slotName] = slot
		slot = slot + 1
	end
end

function ARI_FindSpellSlot( spell )
	return ARI_SpellSlot[spell]
end

function ARI_SpellIsOnCooldown( spell )
	local slot = ARI_FindSpellSlot(spell)
	if slot ~= nil then
		local cooldown = ARI_SpellCooldown[spell]
		if cooldown == nil then
			-- check cooldown and save state
			local start, duration, enabled = GetSpellCooldown( slot, BOOKTYPE_SPELL)
			local remaining = (start + duration - GetTime())
			cooldown = (remaining >= 0)
			ARI_SpellCooldown[spell] = cooldown
		end
		return cooldown
	end
	return false
end


--== mana conserve logic ==--
ARI_ConserveUnit = nil
ARI_ConservePercent = nil
function ARI_CheckManaConserve()
	if ARI_PlayerIsCasting() then
		if ARI_ConserveUnit ~= nil then
			local statusMin, statusMax = CastingBarFrame:GetMinMaxValues()
			local statusValue = CastingBarFrame:GetValue()
			local statusPercent = (statusValue - statusMin) / (statusMax  - statusMin)
			if statusPercent > 0.66 then
				local healthPercent = UnitHealth(ARI_ConserveUnit) / UnitHealthMax(ARI_ConserveUnit)
				if healthPercent > ARI_ConservePercent then
					SpellStopCasting()
				end
			end
		end
		return true
	else
		if ARI_ConserveUnit ~= nil then
			ARI_ConserveUnit = nil
			ARI_ConservePercent = nil
		end
		return false
	end
end

function ARI_SetManaConserve( unit, percent )
	ARI_ConserveUnit = unit
	ARI_ConservePercent = percent
end


--== buff/debuff logic (not to be saved) ==--
ARI_UnitAura = {}
function ARI_ResetUnitAura()
	ARI_UnitAura = {}
end

function ARI_ResetUnitAuraOne( unit )
	ARI_UnitAura[unit] = nil
end

function ARI_UpdateUnitAura( unit )
	-- check if already done
	if ARI_UnitAura[unit] ~= nil then
		return true
	end

	-- rebuild aura list
	ARI_UnitAura[unit] = {}
	local i, buffName = 1, nil

	-- add buffs
	while UnitBuff(unit, i) do
		BoxToolsTooltip:SetUnitBuff(unit, i)
		buffName = tostring(BoxToolsTooltipTextLeft1:GetText())
		ARI_UnitAura[unit][buffName] = true
		i = i + 1
	end

	-- add debuffs (and their type)
	i = 1
	while UnitDebuff(unit, i) do
		_, _, typeName = UnitDebuff(unit, i)
		BoxToolsTooltip:SetUnitDebuff(unit, i)
		buffName = tostring(BoxToolsTooltipTextLeft1:GetText())
		if typeName ~= nil then
			ARI_UnitAura[unit][typeName] = true
		end
		ARI_UnitAura[unit][buffName] = true
		i = i + 1
	end
end

function ARI_UnitHasBuff( unit, spell )
	ARI_UpdateUnitAura(unit)
	return (ARI_UnitAura[unit][spell] ~= nil)
end

function ARI_UnitHasDebuff( unit, spell )
	ARI_UpdateUnitAura(unit)
	return (ARI_UnitAura[unit][spell] ~= nil)
end

function ARI_UnitHasDebuffType( unit, spell )
	ARI_UpdateUnitAura(unit)
	return (ARI_UnitAura[unit][spell] ~= nil)
end


--== Inventory stuff ==--
function ARI_ApplyWeaponBuff( slot, item )
	local container, containerSlot
	for container=0, 4, 1 do
		for containerSlot=1, GetContainerNumSlots(container), 1 do
			BoxToolsTooltip:SetBagItem(container, containerSlot)
			local itemName = tostring(BoxToolsTooltipTextLeft1:GetText())
			if string.find(itemName, item) then
				local _, ItemCount = GetContainerItemInfo(container, containerSlot)
				UseContainerItem(container, containerSlot)
				PickupInventoryItem(slot)
				if CursorHasItem() then ClearCursor() end
				return true
			end
		end
	end
	return false
end

--== CC stuff ==--
function ARI_GetRaidTarget( index )
	ClearTarget()
	for i=0, 10, 1 do
		TargetNearestEnemy()
		if index == GetRaidTargetIndex("target") then
			return true
		end
	end
	ClearTarget()
	return false
end
