function ARI_HunterAssist()
	if ARI_HealHunter() then
		return true
	end

	local leader = ARI_FindLeader()

	AssistUnit(leader)

	if not UnitCanAttack("player", "target") then
		ClearTarget()
		return true
	end

	if UnitIsDead("target") then
		ClearTarget()
		return true
	end

	if ARI_UsePets then
		PetAttack()
	end

	if CheckInteractDistance("target", 3) then
		-- melee range
		if not ARI_IsActionActive(ARI_LOC_ATTACK) then
			if ARI_CastAction(ARI_LOC_ATTACK) then
				return true
			end
		end
	else
		-- ranged range
		if ARI_IsActionValid(ARI_LOC_HUNTERS_MARK) then
			if not ARI_IsImmune(ARI_LOC_HUNTERS_MARK, UnitName("target")) then
				if not ARI_UnitHasDebuff("target", ARI_LOC_HUNTERS_MARK) then
					if ARI_CastAction(ARI_LOC_HUNTERS_MARK) then
						return true
					end
				end
			end
		end

		if UnitName("target") == "Magmadar" then
			if ARI_CastAction(ARI_LOC_TRANQUILIZING_SHOT) then
				return true
			end
		end

		if ARI_UseDots then
			if (UnitPowerType("target") == 0) then
				if ARI_IsActionValid(ARI_LOC_VIPER_STING) then
					if not ARI_IsImmune(ARI_LOC_VIPER_STING, UnitName("target")) then
						if not ARI_UnitHasDebuff("target", ARI_LOC_VIPER_STING) then
							if ARI_CastAction(ARI_LOC_VIPER_STING) then
								return true
							end
						end
					end
				end
			else
				if ARI_IsActionValid(ARI_LOC_SERPENT_STING) then
					if not ARI_IsImmune(ARI_LOC_SERPENT_STING, UnitName("target")) then
						if not ARI_UnitHasDebuff("target", ARI_LOC_SERPENT_STING) then
							if ARI_CastAction(ARI_LOC_SERPENT_STING) then
								return true
							end
						end
					end
				end
			end
		end

		if not ARI_IsActionActive(ARI_LOC_AUTO_SHOT) then
			if ARI_CastAction(ARI_LOC_AUTO_SHOT) then
				return true
			end
		end

		-- check mana
		local manaPercent = UnitMana("player") / UnitManaMax("player")
		if manaPercent > 0.25 then
			if ARI_UsePets then
				if ARI_CastAction(ARI_LOC_BESTIAL_WRATH) then
					return true
				end
			end
			if ARI_CastAction(ARI_LOC_ARCANE_SHOT) then
				return true
			end
			if ARI_CastAction(ARI_LOC_AIMED_SHOT) then
				return true
			end
		end
	end
	return false
end

function ARI_HealHunter()
	if UnitIsDead("player") then
		return true
	end

	-- force view and refresh spell slots
	SetView(5)
	ARI_CheckActionSlots()
	ARI_ResetUnitAura()

	if ARI_UnitHasDebuff("player", ARI_LOC_MANDOKIR_THREATENING_GAZE) then
		if ARI_IsActionActive(ARI_LOC_AUTO_SHOT) then
			if ARI_CastAction(ARI_LOC_AUTO_SHOT) then
				return true
			end
		end
		if ARI_IsActionActive(ARI_LOC_ATTACK) then
			if ARI_CastAction(ARI_LOC_ATTACK) then
				return true
			end
		end
		return true
	end

	if ARI_PlayerIsCasting() then
		return true
	end

	-- check combat
	local inCombat = UnitAffectingCombat("player")
	if inCombat then
		-- check mana (in combat)
		if ARI_UsePotions then
			local manaPercent = UnitMana("player") / UnitManaMax("player")
			if manaPercent < 0.66 then
				if ARI_UnitCastAction("player", ARI_LOC_MAJOR_MANA_POTION) then
					--return true
				end
			end
		end
	end

	-- check self-buffs
	if ARI_IsActionValid(ARI_LOC_ASPECT_OF_THE_HAWK) then
		if not ARI_UnitHasBuff("player", ARI_LOC_ASPECT_OF_THE_HAWK) then
			if ARI_CastAction(ARI_LOC_ASPECT_OF_THE_HAWK) then
				return true
			end
		end
	end

	if ARI_IsActionValid(ARI_LOC_TRUESHOT_AURA) then
		if not ARI_UnitHasBuff("player", ARI_LOC_TRUESHOT_AURA) then
			if ARI_CastAction(ARI_LOC_TRUESHOT_AURA) then
				return true
			end
		end
	end

	if ARI_PetHunter() then
		return true
	end

	-- refresh units in party
	ARI_UpdateUnitNames()

	return false
end

function ARI_PetHunter()
	if ARI_UsePets then
		-- check pet status
		if ARI_IsActionValid(ARI_LOC_CALL_PET) then
			if not UnitExists("pet") then
				if ARI_CastAction(ARI_LOC_CALL_PET) then
					return true
				end
			end

			if UnitIsDead("pet") then
				if ARI_IsActionValid(ARI_LOC_REVIVE_PET) then
					if ARI_CastAction(ARI_LOC_REVIVE_PET) then
						return true
					end
				end
			else
				if ARI_IsActionValid(ARI_LOC_MEND_PET) then
					local healthPercent = UnitHealth("pet") / UnitHealthMax("pet")
					if healthPercent <= 0.5 then
						if ARI_UnitCastAction("pet", ARI_LOC_MEND_PET) then
							return true
						end
					end	
				end
			end
		end
	else
		if UnitExists("pet") then
			if not UnitIsDead("pet") then
				if ARI_CastAction(ARI_LOC_DISMISS_PET) then
					return true
				end
			end
		end
	end


	return false
end
