function ARI_RogueAssist()
	if ARI_HealRogue() then
		return true
	end

	local leader = ARI_FindLeader()

	AssistUnit(leader)

	if not UnitCanAttack("player", "target") then
		ClearTarget()
		return false
	end

	if UnitIsDead("target") then
		ClearTarget()
		return false
	end

	if CheckInteractDistance("target", 3) then
		-- melee range
		if not ARI_IsActionActive(ARI_LOC_ATTACK) then
			if ARI_CastAction(ARI_LOC_ATTACK) then
				return true
			end
		end

		if ARI_IsActionValid(ARI_LOC_SLICE_AND_DICE) then
			if GetComboPoints("player", "target") > 0 then
				if ARI_CastAction(ARI_LOC_SLICE_AND_DICE) then
					return true
				end
			end
		end
		if GetComboPoints("player", "target") > 3 then
			if ARI_CastAction(ARI_LOC_EVISCERATE) then
				return true
			end
		end
		if ARI_CastAction(ARI_LOC_ADRENALINE_RUSH) then
			return true
		end
		if ARI_CastAction(ARI_LOC_BLADE_FLURRY) then
			return true
		end
		if ARI_CastAction(ARI_LOC_SINISTER_STRIKE) then
			return true
		end
	else
		-- ranged range
		BoxToolsTooltip:SetInventoryItem("player", 18)
		local typeName = tostring(BoxToolsTooltipTextLeft2:GetText())
		if typeName == ARI_LOC_SOULBOUND then
			typeName = tostring(BoxToolsTooltipTextLeft3:GetText())
		end
		if typeName == ARI_LOC_CROSSBOW then
			if ARI_CastAction(ARI_LOC_SHOOT_CROSSBOW) then
				return true
			end
		end
		if typeName == ARI_LOC_BOW then
			if ARI_CastAction(ARI_LOC_SHOOT_BOW) then
				return true
			end
		end
		if typeName == ARI_LOC_GUN then
			if ARI_CastAction(ARI_LOC_SHOOT_GUN) then
				return true
			end
		end
		if typeName == ARI_LOC_THROWN then
			if ARI_CastAction(ARI_LOC_THROW) then
				return true
			end
		end
	end

	return false
end

function ARI_HealRogue()
	if ARI_PlayerIsCasting() then
		return true
	end

	-- force view and refresh spell slots
	SetView(5)
	ARI_CheckActionSlots()
	ARI_ResetUnitAura()

	if ARI_UnitHasDebuff("player", ARI_LOC_MANDOKIR_THREATENING_GAZE) then
		if ARI_IsActionActive(ARI_LOC_ATTACK) then
			if ARI_CastAction(ARI_LOC_ATTACK) then
				return true
			end
		end
		return true
	end

	if not UnitAffectingCombat("player") then
		hasMainHandEnchant, mainHandExpiration, mainHandCharges, hasOffHandEnchant, offHandExpiration, offHandCharges = GetWeaponEnchantInfo()
		if hasMainHandEnchant ~= 1 then
			if ARI_ApplyWeaponBuff(16, ARI_LOC_INSTANT_POISON) then
				return true
			end
		end
		if hasOffHandEnchant ~= 1 then
			if ARI_ApplyWeaponBuff(17, ARI_LOC_DEADLY_POISON) then
				return true
			end
		end
	end

	return false
end