function ARI_WarlockAssist()
	if ARI_HealWarlock() then
		return true
	end
	
	local leader = ARI_FindLeader()

	if ARI_UseCC then
		if ARI_IsActionValid(ARI_LOC_BANISH) then
			if ARI_GetRaidTarget(ARI_IconCC) then
				if not ARI_UnitHasDebuff("target", ARI_LOC_BANISH) then
					if ARI_CastAction(ARI_LOC_BANISH) then
						return true
					end
				end
				ARI_ResetUnitAuraOne("target")
				ClearTarget()
			end
		end
	end

	AssistUnit(leader)

	if not UnitCanAttack("player", "target") then
		ClearTarget()
		return false
	end

	if UnitIsDead("target") then
		ClearTarget()
		return false
	end

	if ARI_UseSpells then
		if ARI_IsActionValid(ARI_LOC_CURSE_OF_THE_ELEMENTS) then
			if not ARI_UnitHasDebuff("target", ARI_LOC_CURSE_OF_THE_ELEMENTS) then
				if not ARI_IsImmune(ARI_LOC_CURSE_OF_THE_ELEMENTS, UnitName("target")) then
					if ARI_CastAction(ARI_LOC_CURSE_OF_THE_ELEMENTS) then
						return true
					end
				end
			end
		end

		if ARI_UseDots then
			if ARI_IsActionValid(ARI_LOC_CORRUPTION) then
				if not ARI_IsImmune(ARI_LOC_CORRUPTION, UnitName("target")) then
					if not ARI_UnitHasDebuff("target", ARI_LOC_CORRUPTION) then
						if ARI_CastAction(ARI_LOC_CORRUPTION) then
							return true
						end
					end
				end
			end

			if ARI_IsActionValid(ARI_LOC_IMMOLATE) then
				if not ARI_IsImmune(ARI_LOC_IMMOLATE, UnitName("target")) then
					if not ARI_UnitHasDebuff("target", ARI_LOC_IMMOLATE) then
						if ARI_CastAction(ARI_LOC_IMMOLATE) then
							return true
						end
					end
				end
			end
		end

		if not ARI_IsImmune(ARI_LOC_SHADOW_BOLT, UnitName("target")) then
			if ARI_CastAction(ARI_LOC_SHADOW_BOLT) then
				return true
			end
		end
	end

	-- check mana
	local healthPercent = UnitHealth("player") / UnitHealthMax("player")
	local manaPercent = UnitMana("player") / UnitManaMax("player")
	if manaPercent < 0.50 then
		if healthPercent > 0.75 then
			if ARI_CastAction(ARI_LOC_LIFE_TAP) then
				return true
			end
		end
	end

	if manaPercent < 0.20 then
		if not ARI_IsActionActive(ARI_LOC_SHOOT) then
			if ARI_CastAction(ARI_LOC_SHOOT) then
				return true
			end
		end
	end
	return false
end

function ARI_HealWarlock()
	if UnitIsDead("player") then
		return true
	end

	-- force view and refresh spell slots
	SetView(5)
	ARI_CheckActionSlots()
	ARI_ResetUnitAura()

	if ARI_UnitHasDebuff("player", ARI_LOC_MANDOKIR_THREATENING_GAZE) then
		if ARI_IsActionActive(ARI_LOC_SHOOT) then
			if ARI_CastAction(ARI_LOC_SHOOT) then
				return true
			end
		end
		if ARI_PlayerIsCasting() then
			SpellStopCasting()
		end
		return true
	end

	if ARI_PlayerIsCasting() then
		return true
	end

	-- check mana
	if ARI_UsePotions then
		local manaPercent = UnitMana("player") / UnitManaMax("player")
		if manaPercent < 0.66 then
			if ARI_UnitCastAction("player", ARI_LOC_MAJOR_MANA_POTION) then
				--return true
			end
		end
	end

	-- check buffs
	if ARI_IsActionValid(ARI_LOC_DEMON_ARMOR) then
		if not ARI_UnitHasBuff("player", ARI_LOC_DEMON_ARMOR) then
			if ARI_CastAction(ARI_LOC_DEMON_ARMOR) then
				return true;
			end
		end
	elseif ARI_IsActionValid(ARI_LOC_DEMON_SKIN) then
		if not ARI_UnitHasBuff("player", ARI_LOC_DEMON_SKIN) then
			if ARI_CastAction(ARI_LOC_DEMON_SKIN) then
				return true;
			end
		end
	end

	if ARI_IsActionValid(ARI_LOC_SUMMON_IMP) then
		if not UnitExists("pet") then
			if ARI_CastAction(ARI_LOC_SUMMON_IMP) then
				return true
			end
		end
	end

	-- refresh units in party
	ARI_UpdateUnitNames()

	return false;
end