function ARI_WarriorAssist()
	if ARI_HealWarrior() then
		return true
	end

	local leader = ARI_FindLeader()

	AssistUnit(leader)

	if not UnitCanAttack("player", "target") then
		ClearTarget()
		return false
	end

	if UnitIsDead("target") then
		ClearTarget()
		return false
	end

	if CheckInteractDistance("target", 3) then
		-- melee range
		if not ARI_IsActionActive(ARI_LOC_ATTACK) then
			if ARI_CastAction(ARI_LOC_ATTACK) then
				return true
			end
		end
	else
		-- ranged range
		BoxToolsTooltip:SetInventoryItem("player", 18)
		local typeName = tostring(BoxToolsTooltipTextLeft2:GetText())
		if typeName == ARI_LOC_SOULBOUND then
			typeName = tostring(BoxToolsTooltipTextLeft3:GetText())
		end
		if typeName == ARI_LOC_CROSSBOW then
			if ARI_CastAction(ARI_LOC_SHOOT_CROSSBOW) then
				return true
			end
		end
		if typeName == ARI_LOC_BOW then
			if ARI_CastAction(ARI_LOC_SHOOT_BOW) then
				return true
			end
		end
		if typeName == ARI_LOC_GUN then
			if ARI_CastAction(ARI_LOC_SHOOT_GUN) then
				return true
			end
		end
		if typeName == ARI_LOC_THROWN then
			if ARI_CastAction(ARI_LOC_THROW) then
				return true
			end
		end
	end

	return false
end

function ARI_HealWarrior()
	if UnitIsDead("player") then
		return true
	end
	if ARI_PlayerIsCasting() then
		return true
	end

	-- force view and refresh spell slots
	SetView(5)
	ARI_CheckActionSlots()
	ARI_ResetUnitAura()

	-- refresh units in party
	ARI_UpdateUnitNames()

	return false
end